config/routes.rb
Rails.application.routes.draw do
  resources :todos, only: [:index, :create, :update, :destroy], :path => '' do
    collection do
      put :update_many
      delete :destroy_many
    end
  end

  root "todos#index"
end

app/models/todo.rb
class Todo < ActiveRecord::Base
  before_validation { |t| t.title.try(:strip!) }
  validates :title, presence: true

  scope :completed, -> (status) { where(is_completed: status) }
  scope :belonging_to, -> (session_user_id) { where(session_user_id: session_user_id) }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  private

  def session_user
    @session_user ||= session[:user_id] || generate_session_user_id
  end

  def generate_session_user_id
    session[:user_id] = SecureRandom.hex
  end
end

app/controllers/todos_controller.rb
class TodosController < ApplicationController
  # GET /todos
  def index
    load_todos
  end

  # POST /todos
  def create
    Todo.belonging_to(session_user).create(todo_params)
    load_and_render_index
  end

  # PATCH/PUT /todos/1
  def update
    # cheat - sometimes the blur event handler asks to update an already destroyed record.
    Todo.belonging_to(session_user).where(id: params[:id]).update_all(todo_params.to_h)
    load_and_render_index
  end

  def update_many
    Todo.belonging_to(session_user).where(id: params[:ids]).update_all(todo_params.to_h)
    load_and_render_index
  end

  # DELETE /todos/1
  def destroy
    # same problem as on update - sometimes we try to destroy twice in the JS
    Todo.belonging_to(session_user).find_by(id: params[:id]).try(:destroy)
    load_and_render_index
  end

  def destroy_many
    Todo.belonging_to(session_user).where(id: params[:ids]).try(:destroy_all)
    load_and_render_index
  end

  private
    # Never trust parameters from the scary internet, only allow the white list through.
    def todo_params
      params.require(:todo).permit(:title, :is_completed)
    end

    def filtering_params
      params.slice(:completed).to_unsafe_h
    end
    helper_method :filtering_params

    def load_and_render_index
      load_todos
      render :index, change: "todos"
    end

    def load_todos
      @todos = Todo.belonging_to(session_user).order(created_at: :asc)

      filtering_params.each do |key, value|
        @todos = @todos.public_send(key, value) if value.present?
      end
    end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <% cache('head') do %>
    <title>Turbolinks 3 • TodoMVC</title>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true, async: true, defer: true %>
    <meta name=viewport content="width=device-width, initial-scale=1">
  <% end %>

  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

<% cache('footer') do %>
  <footer id="info" data-turbolinks-permanent>
    <p>Double-click to edit a todo</p>
    <p>Created by <a href="http://twitter.com/nateberkopec">Nate Berkopec</a></p>
    <p>Part of <a href="http://todomvc.com">TodoMVC</a></p>
  </footer>
<% end %>

</body>
</html>

app/views/todos/index.html.erb
<section id="todoapp">
  <header id="header" data-turbolinks-permanent>
    <h1>todos</h1>
    <%= form_for Todo.new, remote: true, authenticity_token: true do |f| %>
      <%= f.text_field :title, id: "new-todo", placeholder: "What needs to be done?", autofocus: true, autocomplete: "off" %>
    <% end %>
  </header>
  <% @todos.load %>
  <section id="main">
    <%= form_tag update_many_todos_path, method: :put, remote: true, "data-turbolinks-temporary" => true, id: "update_many_todos", authenticity_token: true do %>
      <% @todos.map do |todo| %>
        <%= hidden_field_tag "ids[]", todo.id %>
      <% end %>
      <%= check_box :todo, :is_completed, checked: @todos.any? && @todos.all?(&:is_completed), id: "toggle-all", "data-behavior": "submit_on_check" %>
      <label for="toggle-all">Mark all as complete</label>
    <% end %>
    <ul id="todos">
      <% @todos.each do |todo| %>
        <li id="todos:<%= todo.id %>" class="<%= 'completed' if todo.is_completed %>" data-behavior="toggle_form_on_dblclick">
          <div class="view">
            <%= form_for todo, remote: true, authenticity_token: true do |f| %>
              <%= f.check_box :is_completed, class: "toggle", "data-behavior": "submit_on_check" %>
            <% end %>

            <label class="toggle-me"><%= todo.title %></label>

            <%= form_for todo, remote: true, authenticity_token: true, method: "delete", html: { class: "destroy_todo" } do |f| %>
              <%= button_tag "", class: "destroy" %>
            <% end %>
          </div>
          <%= form_for todo, remote: true, html: { class: "toggle-me todo-title", style: "display: none", "data-behavior": "intercept_destroy" } do |f|%>
            <%= f.text_field :title, class: "edit", "data-behavior": "submit_on_blur close_on_esc", autocomplete: "off" %>
          <% end %>
        </li>
      <% end %>
    </ul>
  </section>
  <footer id="footer" data-turbolinks-temporary class="<%= "hidden" unless @todos.any? || filtering_params.any? %>">
    <span id="todo-count">
      <%= pluralize @todos.reject(&:is_completed).size, "item" %> left
    </span>
    <ul id="filters">
      <li>
        <a id="all" href="/" class="<%= "selected" if request.fullpath == '/' || request.fullpath == "/todos" %>">All</a>
      </li>
      <li>
        <a id="active" href="/?completed=false" class="<%= "selected" if request.fullpath.match("completed=false") %>">Active</a>
      </li>
      <li>
        <a id="completed" href="/?completed=true" class="<%= "selected" if request.fullpath.match("completed=true") %>">Completed</a>
      </li>
    </ul>
    <% if @todos.select { |t| t.is_completed }.size > 0 %>
      <%= form_tag destroy_many_todos_path, remote: true, authenticity_token: true, method: :delete do %>
        <% @todos.select { |t| t.is_completed }.map do |todo| %>
          <%= hidden_field_tag "ids[]", todo.id %>
        <% end %>
        <%= button_tag "Clear completed", id: "clear-completed" %>
      <% end %>
    <% end %>
  </footer>
</section>